<template>
    <base-card>
    <h2>Encuentra tu mascota ideal</h2>
    <span class="opcion-filtro">
        <input type="checkbox" id="perro" checked @change="setFiltro">
        <label for="perro">Perro</label>
    </span>
    <span class="opcion-filtro">
        <input type="checkbox" id="gato" checked @change="setFiltro">
        <label for="gato">Gato</label>
    </span>
    </base-card>
</template>
<script>
export default {
    emits:['cambio-filtro'],
    data(){
        return{
            filtros:{
                perro:true,
                gato:true
            }
        };
    },
    methods:{
        setFiltro(event){
            const inputId=event.target.id;
            const esActivo=event.target.checked;
            const filtroActualizado={
                ...this.filtros,
                [inputId]:esActivo
            };
            this.filtros=filtroActualizado;
            this.$emit('cambio-filtro', filtroActualizado);
        }
    }
}
</script>
<style scoped>
h2 {
  margin: 0.5rem 0;
}

.filter-option {
  margin-right: 1rem;
}

.filter-option label,
.filter-option input {
  vertical-align: middle;
}

.filter-option label {
  margin-left: 0.25rem;
}

.filter-option.active label {
  font-weight: bold;
}
</style>

import 'ag-grid-community/styles/ag-grid.css';
import 'ag-grid-community/styles/ag-theme-alpine.css';
import 'ag-grid-enterprise';
import { AgGridVue } from 'ag-grid-vue';
import Vue from 'vue';

const VueExample = {
  template: `
        <div style="height: 100%">
            <ag-grid-vue
                
                style="width: 100%; height: 100%;"
                class="ag-theme-alpine"
                :columnDefs="columnDefs"
                @grid-ready="onGridReady"
                :defaultColDef="defaultColDef"
                :sideBar="sideBar"
                :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    'ag-grid-vue': AgGridVue,
  },
  data: function () {
    return {
      columnDefs: [
        {
          field: 'athlete',
          filter: 'agMultiColumnFilter',
          filterParams: {
            filters: [
              { filter: 'agTextColumnFilter', display: 'subMenu' },
              { filter: 'agSetColumnFilter' },
            ],
          },
        },
        {
          field: 'country',
          filter: 'agMultiColumnFilter',
          filterParams: {
            filters: [
              {
                filter: 'agTextColumnFilter',
                display: 'accordion',
                title: 'Expand Me for Text Filters',
              },
              { filter: 'agSetColumnFilter', display: 'accordion' },
            ],
          },
        },
        { field: 'sport', filter: 'agMultiColumnFilter' },
      ],
      gridApi: null,
      columnApi: null,
      defaultColDef: {
        flex: 1,
        minWidth: 200,
        resizable: true,
        menuTabs: ['filterMenuTab'],
      },
      sideBar: null,
      rowData: null,
    };
  },
  created() {
    this.sideBar = {
      toolPanels: [
        {
          id: 'filters',
          labelDefault: 'Filters',
          labelKey: 'filters',
          iconKey: 'filter',
          toolPanel: 'agFiltersToolPanel',
        },
      ],
    };
  },
  methods: {
    onGridReady(params) {
      this.gridApi = params.api;
      this.gridColumnApi = params.columnApi;

      const updateData = (data) => params.api.setRowData(data);

      fetch('https://www.ag-grid.com/example-assets/olympic-winners.json')
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    },
  },
};

new Vue({
  el: '#app',
  components: {
    'my-component': VueExample,
  },
});